import os,sys,subprocess,math;
from compilelib import *;
import shutil;
from distutils.dir_util import copy_tree as copy_tree; #this version does overwrites

kwargs = dict();

include = "-I./include";
kwargs['include'] = include;

kwargs['flags'] = "-fPIC";
kwargs['libdir'] = "-L./bin_winx64 -L../../lib_winx64";
kwargs['libflags'] = "-lamsstring.mingw64";
kwargs['linkerflags'] = "-static -static-libgcc -Wl,-rpath=."
kwargs['recurse'] = True;


MinGWdir = "C:\\\\mingw64\\bin"; #The location of my mingw installation
pth = os.environ['PATH'];
os.environ['PATH'] = MinGWdir+';'+pth;

#1: Pull required binary dynamic libraries to the bin folder
#I'm pretty sure libamslapack is not strongly coupled to anything in this lib.
#I'm including it anyway for further development later.
#shutil.copy('../../lib_winx64/libamslapack.a','./bin_winx64');
#shutil.copy('../../lib_winx64/libamslapack.dll','./bin_winx64');

#2: Pull updated versions of all include files to the include folder
#copy_tree('../../include_winx64/amsmath','./include/amsmath');

f1 = ['./src/main_test.cpp'];
f2 = replaceexts(f1,'.o');

#3: Compile any test programs
gpp_compile_list(f1,**kwargs);
gs_link_list('g++',list_to_sss(f2),'./bin_winx64/main_test.exe',**kwargs);
