import os,sys,subprocess,math;
from compilelib import *;
import shutil;
from distutils.dir_util import copy_tree as copy_tree; #this version does overwrites

def except_contains(lst1,exc):
    lst2 = [];
    for item in lst1:
        b = 1;
        for item2 in exc:
            if(item.find(item2)>=0):
                b = 0;
                break;
        if(b==1):
            lst2.append(item);
    return lst2;

kwargs = dict();

include = "-I./include";
kwargs['include'] = include;

kwargs['flags'] = "-fPIC";
kwargs['libdir'] = "-L./bin_winx64";
kwargs['libflags'] = "";
kwargs['linkerflags'] = "-static -static-libgcc -Wl,-rpath=."
kwargs['recurse'] = True;

#Set up the path
MinGWdir = "C:\\\\mingw64\\bin"; #The location of my mingw installation
pth = os.environ['PATH'];
os.environ['PATH'] = MinGWdir+';'+pth;

#1: Pull required binary dynamic libraries to the bin folder
#shutil.copy('../../lib_winx64/libamslapack.a','./bin_winx64');
#shutil.copy('../../lib_winx64/libamslapack.dll','./bin_winx64');
#none required here...

#2: Pull updated versions of all include files to the include folder
#copy_tree('../../include_winx64/amsmath','./include/amsmath');


#find all source files except the main test file
f1 = flist('./src',exts=['.c','.cpp'],recurse=True);
f2 = except_contains(f1,['main_test.cpp']);
f2a = list_to_sss(f2);
#print f2a;
f3 = replaceexts(f2,'.o');

#compile all source files in the list
gpp_compile_list(f2,**kwargs);
#archive all source files in a static library
ar_list(f3,'./bin_winx64/libamsstring.mingw64.a');

#X: Push any libraries to the common lib folder
shutil.copy('./bin_winx64/libamsstring.mingw64.a','../../lib_winx64');

#Y: Push any changes to the include files to the common include folder
copy_tree('./include/amsstring','../../include_winx64/amsstring');
